osl::eval::ppair::PiecePairEval< Eval, Table > Class Template Reference

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
osl::eval::ppair::PiecePairEval< Eval, Table > Class Template Reference

駒のペアの統計情報を元にした評価関数の共通部分. More...

`#include <piecePairEval.h>`

Inheritance diagram for osl::eval::ppair::PiecePairEval< Eval, Table >:
[legend]
Collaboration diagram for osl::eval::ppair::PiecePairEval< Eval, Table >:
[legend]

## Public Types
typedef PiecePairEvalTableBase < Table > | base_t

## Public Member Functions
void | changeTurn ()
int | expect (const SimpleState &state, Move m) const
| この時 state は move する前 More...
void | update (const SimpleState &new_state, Move last_move)
| この時 state は move した後 More...

## Static Public Member Functions
static int | diffWithMove (const SimpleState &state, Move move)
Static Public Member Functions inherited from osl::eval::ppair::PiecePairEvalTableBase< Table >
static int | adjustPairs (const SimpleState &state, unsigned int new_index)
| 駒が old_index から new_index に動いたときの値の差分 More...
static int | adjustPairs (const SimpleState &state, unsigned int old_index, unsigned int new_index)
static int | adjustPairs (const SimpleState &state, unsigned int old_index, unsigned int old_index2, unsigned int new_index)
static int | diffAfterSimpleMove (const SimpleState &state, Square from, Square to, int promote_mask)
static int | diffAfterDropMove (const SimpleState &state, Square to, PtypeO ptypeo)
static int | diffAfterCaptureMove (const SimpleState &state, Square from, Square to, PtypeO victim, int promote_mask)
static int | adjustPairsAfterMove (const SimpleState &state, unsigned int new_index)
| この時 state は move した後 More...
static int | adjustPairsAfterMove (const SimpleState &state, unsigned int old_index, unsigned int new_index)
static int | adjustPairsAfterMove (const SimpleState &state, unsigned int old_index, unsigned int old_index2, unsigned int new_index)
static int | diffWithUpdate (const SimpleState &new_state, Move last_move)
static void | setValues (const SimpleState &, container::PieceValues &)
| 関係の値をPiece 毎の価値に変換する. More...
static bool | initialized ()
static bool | setUp (const char *filename)
static bool | setUp ()
Static Public Member Functions inherited from osl::eval::ppair::PiecePairEvalBase
static int | roundUp (int v)
static int | infty ()
static int | captureValue (PtypeO ptypeo)

## Protected Member Functions
| PiecePairEval (const SimpleState &state)
Protected Member Functions inherited from osl::eval::ppair::PiecePairEvalTableBase< Table >
| PiecePairEvalTableBase (const SimpleState &state)
| ~PiecePairEvalTableBase ()
Protected Member Functions inherited from osl::eval::ppair::PiecePairEvalBase
| PiecePairEvalBase ()
| ~PiecePairEvalBase ()

## Additional Inherited Members
Static Public Attributes inherited from osl::eval::ppair::PiecePairEvalBase
static const int | ROUND_UP = 2
| roundup は 2^n であること More...
Protected Attributes inherited from osl::eval::ppair::PiecePairEvalBase
int | val

## Detailed Description

### template<class Eval, class Table>
class osl::eval::ppair::PiecePairEval< Eval, Table >

駒のペアの統計情報を元にした評価関数の共通部分.

- 必ず偶数
- 先手有利 +, 後手有利 -
  Parameters

    Table | PiecePairTable のどれかのinstatiationを想定

Definition at line 154 of file piecePairEval.h.

## Member Typedef Documentation

template<class Eval, class Table>

typedef PiecePairEvalTableBase<Table> osl::eval::ppair::PiecePairEval< Eval, Table >::base_t

Definition at line 160 of file piecePairEval.h.

## Constructor & Destructor Documentation

template<class Eval , class Table >

osl::eval::ppair::PiecePairEval< Eval, Table >::PiecePairEval | ( | const SimpleState & | state) |  |
| explicitprotected

Definition at line 228 of file piecePairEval.tcc.

## Member Function Documentation

template<class Eval, class Table>

void osl::eval::ppair::PiecePairEval< Eval, Table >::changeTurn | ( | ) |  |
| inline

Definition at line 161 of file piecePairEval.h.

template<class Eval, class Table>

static int osl::eval::ppair::PiecePairEval< Eval, Table >::diffWithMove | ( | const SimpleState & | state,
|  | Move | move
| ) |  |
| inlinestatic

Definition at line 172 of file piecePairEval.h.

template<class Eval , class Table >

int osl::eval::ppair::PiecePairEval< Eval, Table >::expect | ( | const SimpleState & | state,
|  | Move | m
| ) |  | const

この時 state は move する前

Definition at line 235 of file piecePairEval.tcc.

References osl::Move::capturePtype(), osl::Move::capturePtypeO(), osl::Piece::EMPTY(), osl::Move::from(), osl::Move::isDrop(), osl::newPtypeO(), piece_pair_assert, osl::Move::promoteMask(), osl::Move::ptype(), osl::PTYPE_EMPTY, and osl::Move::to().

template<class Eval, class Table>

void osl::eval::ppair::PiecePairEval< Eval, Table >::update | ( | const SimpleState & | new_state,
|  | Move | last_move
| ) |  |
| inline

この時 state は move した後

Definition at line 167 of file piecePairEval.h.

The documentation for this class was generated from the following files:

- piecePairEval.h
- piecePairEval.tcc